function scores = crossCorrelation(F, timeLag)
F = discretizeFluorescenceSignal(F,'bins',3);

[row col] = size(F);
arr = [];
for i=1:1:col
    for j=i+1:1:col
        crossCorr = myxcorr(F(:,i),F(:,j),timeLag);
        Values_ij = mean(crossCorr(1:timeLag+1));        
        Values_ji = mean(crossCorr(timeLag+1:2*timeLag+1));
        
        arr = [arr;i j Values_ij];
        arr = [arr;j i Values_ji];
    end
end

scores =  sparse(arr(:,1), arr(:,2), arr(:,3), col,col);


function crossCorr = myxcorr(x,y,timeLag)
index = 1;
n = length(x);
for i=-timeLag:1:-1
    j = -i;
    crossCorr(index) = y(j+1:n)'*x(1:n-j);
    index = index+1;
end

for i=0:timeLag
    
    crossCorr(index) = x(i+1:n)'*y(1:n-i);
    index = index+1;
end

crossCorr = crossCorr/sqrt(x'*x)/sqrt(y'*y);