function H = entropy(X)
% Written by Mo Chen (mochen80@gmail.com).
% Source: http://www.mathworks.com/matlabcentral/fileexchange/35625-information-theory-toolbox
% Modified by Karan

[nlin, ncol]=size(X); 
if ncol==1,
    dim=1;
elseif nlin==1,
    dim=2;
else
    dim=1;
end


if dim==1 
    H=zeros(1,ncol);
    for k=1:ncol
        [u,~,label] = unique(X(:,k));
        p = full(mean(sparse(1:nlin,label,1,nlin,numel(u),nlin),1));
        H(k) = -dot(p,log2(p+eps));
    end
else
    H=zeros(nlin,1);
    for k=1:nlin
        [u,~,label] = unique(X(k,:));
        p = full(mean(sparse(1:ncol,label,1,ncol,numel(u),ncol),1));
        H(k) = -dot(p,log2(p+eps));
    end
end

end