function [scoresPval scoresFstat] = granger(F, timeLag)
%F = discretizeFluorescenceSignal(F,'bins',3);
[row col] = size(F);

scoresPval = zeros(col,col);
scoresFstat = zeros(col,col);
for i=1:1:col
    for j=i+1:1:col
        [pij fstatij] = calculateIndex(F(:,i),F(:,j),timeLag);        
        [pji fstatji] = calculateIndex(F(:,j),F(:,i),timeLag);        

        scoresPval(i,j) = pij;
        scoresPval(j,i) = pji;
        
        scoresFstat(i,j) = fstatij;
        scoresFstat(j,i) = fstatji;
        
    end
end

function [pVal Fstatistic] = calculateIndex(y,x,p)
%%% See --> http://support.sas.com/rnd/app/examples/ets/granger/
timeSteps = length(x);

currentX = x(1+p:timeSteps,1);
pastX = [ones(timeSteps-p,1)];
for i=1:p
    pastX = [pastX x(i:timeSteps-i,1)];
end
[b1 bint1 residuals1] = regress(currentX,pastX);
RSS0 = residuals1'*residuals1;


for i=1:p
    pastX = [pastX y(i:timeSteps-i,1)];
end
[b2 bint2 residuals2] = regress(currentX,pastX);
RSS1 = residuals2'*residuals2;

Fstatistic = (RSS0-RSS1)/p;
Fstatistic = Fstatistic/RSS1*(timeSteps-2*p-1);

pVal = 1-fcdf(Fstatistic,p,timeSteps-2*p-1);