function H = jointEntropy(X, Y, dim)
% Written by Mo Chen (mochen80@gmail.com).
% Source: http://www.mathworks.com/matlabcentral/fileexchange/35625-information-theory-toolbox
% Modified by Karan
    
[nlin, ncol]=size(X);
Y=[];
if ncol==1,
    dim=1;
    X=[X,Y];
elseif nlin==1,
    dim=2;
    X=[X;Y];
else
    dim=1;
end

if dim==2, X=X'; end

% This assumes discrete integer values
[p,n]=size(X);
m = min(min(X));
if m~=1, X = X-m+1; end

M = max(max(X));
idx = 1:nlin;
H=zeros(ncol,ncol);
tot=ncol*(ncol+1)/2;
k=0;
for i=1:ncol
    for j=i:ncol
        p = nonzeros(sparse(idx,X(:,i),1,nlin,M,nlin)'*...
                     sparse(idx,X(:,j),1,nlin,M,nlin)/nlin); %joint distribution of x and y
        H(i,j) = -dot(p,log2(p+eps));
        H(j,i) = H(i,j);
        k=k+1;
    end
end
end
