function [trainPredictions m] = learnModel(dat,truthValues)

classifier = zarbi;
scoringMethods = {@crossCorrelation,@transferEntropy,@gainGini,@gainEntropy};
[T n] = size(dat);

featureMatrix = computeFeatures(dat,scoringMethods);

labels = reshape(full(truthValues),n*n,1);
labels(labels==0)=-1;
trainData.X=featureMatrix;
trainData.Y=labels;
[trainPredictions trainModel] = train(classifier,trainData);

trainPredictions = trainPredictions.X;

m.scoringMethods = scoringMethods;
m.trainModel = trainModel;
