fprintf('Using %s.\n', 'Linear Classifier');

trainingFile = [pwd filesep 'fluorescence_mocktest.mat'];
F = load(trainingFile);
trainingData = F.M;
 
trainNetworkFile = [pwd filesep 'network_mocktest.txt'];
trainNetwork = readNetworkScores(trainNetworkFile);
[trainPredictions, Model] = learnModel(trainingData, trainNetwork);

modelFile = [pwd filesep 'model_new'];
save(modelFile, 'Model');

h = figure('Name', [trainNetworkID ' ROC curve']);
[AUC, FPR, TPR, TPRatMark, raw] = computeROC(trainNetwork, trainPredictions, 'plot', h);
fprintf('AUC = %5.5f\n', AUC);

fclose all;